Index: trunk/src/kernel32/KERNEL32.CPP
===================================================================
--- trunk/src/kernel32/KERNEL32.CPP	(revision 3864)
+++ trunk/src/kernel32/KERNEL32.CPP	(revision 3872)
@@ -1,3 +1,3 @@
-/* $Id: KERNEL32.CPP,v 1.49 2000-07-06 21:18:38 sandervl Exp $ */
+/* $Id: KERNEL32.CPP,v 1.50 2000-07-20 18:06:58 sandervl Exp $ */
 
 /*
@@ -707,17 +707,4 @@
 
 
-ODINFUNCTION4(BOOL,    GetStringTypeW,
-              DWORD,   dwInfoType,
-              LPCWSTR, lpSrcStr,
-              int,     cchSrc,
-              LPWORD,  lpCharType)
-{
-  return GetStringTypeExW(0,
-                          dwInfoType,
-                          lpSrcStr,
-                          cchSrc,
-                          lpCharType);
-}
-
 
 ODINFUNCTION5(BOOL,    GetStringTypeExW,
@@ -771,15 +758,11 @@
 }
 
-//******************************************************************************
-//NOTE: This has one parameter more than the W version! (@#$@#$)
-//******************************************************************************
-ODINFUNCTION5(BOOL,    GetStringTypeA,
-              LCID,    locale,
+ODINFUNCTION4(BOOL,    GetStringTypeW,
               DWORD,   dwInfoType,
-              LPCSTR,  lpSrcStr,
+              LPCWSTR, lpSrcStr,
               int,     cchSrc,
               LPWORD,  lpCharType)
 {
-  return GetStringTypeExA(locale,
+  return ODIN_GetStringTypeExW(0,
                           dwInfoType,
                           lpSrcStr,
@@ -854,4 +837,20 @@
 }
 
+//******************************************************************************
+//NOTE: This has one parameter more than the W version! (@#$@#$)
+//******************************************************************************
+ODINFUNCTION5(BOOL,    GetStringTypeA,
+              LCID,    locale,
+              DWORD,   dwInfoType,
+              LPCSTR,  lpSrcStr,
+              int,     cchSrc,
+              LPWORD,  lpCharType)
+{
+  return ODIN_GetStringTypeExA(locale,
+                          dwInfoType,
+                          lpSrcStr,
+                          cchSrc,
+                          lpCharType);
+}
 
 //******************************************************************************
Index: trunk/src/kernel32/exceptions.cpp
===================================================================
--- trunk/src/kernel32/exceptions.cpp	(revision 3864)
+++ trunk/src/kernel32/exceptions.cpp	(revision 3872)
@@ -1,3 +1,3 @@
-/* $Id: exceptions.cpp,v 1.41 2000-05-18 09:08:37 sandervl Exp $ */
+/* $Id: exceptions.cpp,v 1.42 2000-07-20 18:06:59 sandervl Exp $ */
 
 /*
@@ -310,5 +310,5 @@
   if(!pRecord)
   {
-    record.ExceptionCode    = STATUS_INVALID_DISPOSITION;
+    record.ExceptionCode    = STATUS_UNWIND;
     record.ExceptionFlags   = 0;
     record.ExceptionRecord  = NULL;
Index: trunk/src/kernel32/winimagepeldr.cpp
===================================================================
--- trunk/src/kernel32/winimagepeldr.cpp	(revision 3864)
+++ trunk/src/kernel32/winimagepeldr.cpp	(revision 3872)
@@ -1,3 +1,3 @@
-/* $Id: winimagepeldr.cpp,v 1.49 2000-06-28 18:08:36 sandervl Exp $ */
+/* $Id: winimagepeldr.cpp,v 1.50 2000-07-20 18:07:00 sandervl Exp $ */
 
 /*
@@ -676,4 +676,12 @@
  ULONG  baseAddress;
 
+  realBaseAddress = 0;
+
+  //Allocated in peldr.dll
+  if(reservedMem && reservedMem == oh.ImageBase) {
+	realBaseAddress = oh.ImageBase;
+	return TRUE;
+  }
+
   //SvL: We don't care where the image is loaded for resource lookup
   if(fh.Characteristics & IMAGE_FILE_RELOCS_STRIPPED && loadType == REAL_LOAD) {
@@ -755,12 +763,4 @@
  APIRET rc;
  BOOL   allocFlags = flAllocMem;
-
-  realBaseAddress = 0;
-
-  //Allocated in peldr.dll
-  if(reservedMem && reservedMem == oh.ImageBase) {
-	realBaseAddress = oh.ImageBase;
-	return TRUE;
-  }
 
   //Reserve enough space to store 4096 pointers to 1MB memory chunks
Index: trunk/src/peldr/pe.cpp
===================================================================
--- trunk/src/peldr/pe.cpp	(revision 3864)
+++ trunk/src/peldr/pe.cpp	(revision 3872)
@@ -1,3 +1,3 @@
-/* $Id: pe.cpp,v 1.19 2000-07-15 17:12:02 sandervl Exp $ */
+/* $Id: pe.cpp,v 1.20 2000-07-20 18:06:29 sandervl Exp $ */
 
 /*
@@ -272,7 +272,7 @@
     	goto end;
   }
-  if(!(fh.Characteristics & IMAGE_FILE_RELOCS_STRIPPED)) {
-	goto end; //no need to allocate anything now
-  }
+//  if(!(fh.Characteristics & IMAGE_FILE_RELOCS_STRIPPED)) {
+//	goto end; //no need to allocate anything now
+//  }
 
   // check for high memory support