Index: /trunk/libc/src/libc/process/Makefile.kmk
===================================================================
--- /trunk/libc/src/libc/process/Makefile.kmk	(revision 3880)
+++ /trunk/libc/src/libc/process/Makefile.kmk	(revision 3881)
@@ -1,3 +1,3 @@
-# $Id: $
+# $Id$
 ## @file
 #
Index: /trunk/libc/src/libc/process/_execname.c
===================================================================
--- /trunk/libc/src/libc/process/_execname.c	(revision 3880)
+++ /trunk/libc/src/libc/process/_execname.c	(revision 3881)
@@ -1,3 +1,3 @@
-/* $Id: $ */
+/* $Id$ */
 /** @file
  *
Index: /trunk/libc/src/libc/process/_gettid.c
===================================================================
--- /trunk/libc/src/libc/process/_gettid.c	(revision 3880)
+++ /trunk/libc/src/libc/process/_gettid.c	(revision 3881)
@@ -1,3 +1,3 @@
-/* $Id: $ */
+/* $Id$ */
 /** @file
  *
Index: /trunk/libc/src/libc/process/_sleep2.c
===================================================================
--- /trunk/libc/src/libc/process/_sleep2.c	(revision 3880)
+++ /trunk/libc/src/libc/process/_sleep2.c	(revision 3881)
@@ -1,3 +1,3 @@
-/* $Id: $ */
+/* $Id$ */
 /** @file
  *
Index: /trunk/libc/src/libc/process/clock.c
===================================================================
--- /trunk/libc/src/libc/process/clock.c	(revision 3880)
+++ /trunk/libc/src/libc/process/clock.c	(revision 3881)
@@ -1,3 +1,3 @@
-/* $Id: $ */
+/* $Id$ */
 /** @file
  *
Index: /trunk/libc/src/libc/process/fork.c
===================================================================
--- /trunk/libc/src/libc/process/fork.c	(revision 3880)
+++ /trunk/libc/src/libc/process/fork.c	(revision 3881)
@@ -1,3 +1,3 @@
-/* $Id: $ */
+/* $Id$ */
 /** @file
  *
Index: /trunk/libc/src/libc/process/getpid.c
===================================================================
--- /trunk/libc/src/libc/process/getpid.c	(revision 3880)
+++ /trunk/libc/src/libc/process/getpid.c	(revision 3881)
@@ -1,3 +1,3 @@
-/* $Id: $ */
+/* $Id$ */
 /** @file
  *
Index: /trunk/libc/src/libc/process/getppid.c
===================================================================
--- /trunk/libc/src/libc/process/getppid.c	(revision 3880)
+++ /trunk/libc/src/libc/process/getppid.c	(revision 3881)
@@ -1,3 +1,3 @@
-/* $Id: $ */
+/* $Id$ */
 /** @file
  *
Index: /trunk/libc/src/libc/process/getrlimit.c
===================================================================
--- /trunk/libc/src/libc/process/getrlimit.c	(revision 3880)
+++ /trunk/libc/src/libc/process/getrlimit.c	(revision 3881)
@@ -1,3 +1,3 @@
-/* $Id: $ */
+/* $Id$ */
 /** @file
  *
Index: /trunk/libc/src/libc/process/getrusage.c
===================================================================
--- /trunk/libc/src/libc/process/getrusage.c	(revision 3880)
+++ /trunk/libc/src/libc/process/getrusage.c	(revision 3881)
@@ -1,3 +1,3 @@
-/* $Id: $ */
+/* $Id$ */
 /** @file
  *
Index: /trunk/libc/src/libc/process/kill.c
===================================================================
--- /trunk/libc/src/libc/process/kill.c	(revision 3880)
+++ /trunk/libc/src/libc/process/kill.c	(revision 3881)
@@ -1,3 +1,3 @@
-/* $Id: $ */
+/* $Id$ */
 /** @file
  *
Index: /trunk/libc/src/libc/process/nt/_errno-nt.c
===================================================================
--- /trunk/libc/src/libc/process/nt/_errno-nt.c	(revision 3880)
+++ /trunk/libc/src/libc/process/nt/_errno-nt.c	(revision 3881)
@@ -1,3 +1,3 @@
-/* $Id: $ */
+/* $Id$ */
 /** @file
  *
Index: /trunk/libc/src/libc/process/pause.c
===================================================================
--- /trunk/libc/src/libc/process/pause.c	(revision 3880)
+++ /trunk/libc/src/libc/process/pause.c	(revision 3881)
@@ -1,3 +1,3 @@
-/* $Id: $ */
+/* $Id$ */
 /** @file
  *
Index: /trunk/libc/src/libc/process/raise.c
===================================================================
--- /trunk/libc/src/libc/process/raise.c	(revision 3880)
+++ /trunk/libc/src/libc/process/raise.c	(revision 3881)
@@ -1,3 +1,3 @@
-/* $Id: $ */
+/* $Id$ */
 /** @file
  *
Index: /trunk/libc/src/libc/process/setrlimit.c
===================================================================
--- /trunk/libc/src/libc/process/setrlimit.c	(revision 3880)
+++ /trunk/libc/src/libc/process/setrlimit.c	(revision 3881)
@@ -1,3 +1,3 @@
-/* $Id: $ */
+/* $Id$ */
 /** @file
  *
Index: /trunk/libc/src/libc/process/sigempty.c
===================================================================
--- /trunk/libc/src/libc/process/sigempty.c	(revision 3880)
+++ /trunk/libc/src/libc/process/sigempty.c	(revision 3881)
@@ -1,3 +1,3 @@
-/* $Id: $ */
+/* $Id$ */
 /** @file
  *
Index: /trunk/libc/src/libc/process/sigfills.c
===================================================================
--- /trunk/libc/src/libc/process/sigfills.c	(revision 3880)
+++ /trunk/libc/src/libc/process/sigfills.c	(revision 3881)
@@ -1,3 +1,3 @@
-/* $Id: $ *//* sigfills.c (emx+gcc) -- Copyright (c) 1994-1995 by Eberhard Mattes */
+/* $Id$ *//* sigfills.c (emx+gcc) -- Copyright (c) 1994-1995 by Eberhard Mattes */
 /** @file
  *
Index: /trunk/libc/src/libc/process/signal.c
===================================================================
--- /trunk/libc/src/libc/process/signal.c	(revision 3880)
+++ /trunk/libc/src/libc/process/signal.c	(revision 3881)
@@ -1,3 +1,3 @@
-/* $Id: $ */
+/* $Id$ */
 /** @file
  *
Index: /trunk/libc/src/libc/process/sleep.c
===================================================================
--- /trunk/libc/src/libc/process/sleep.c	(revision 3880)
+++ /trunk/libc/src/libc/process/sleep.c	(revision 3881)
@@ -1,3 +1,3 @@
-/* $Id: $ */
+/* $Id$ */
 /** @file
  *
Index: /trunk/libc/src/libc/process/system.c
===================================================================
--- /trunk/libc/src/libc/process/system.c	(revision 3880)
+++ /trunk/libc/src/libc/process/system.c	(revision 3881)
@@ -1,3 +1,3 @@
-/* $Id: b_processSetResourceLimit.c 3770 2012-03-15 20:02:46Z bird $ */
+/* $Id$ */
 /** @file
  * kNIX - get default shell for system() and popen().
Index: /trunk/libc/src/libc/process/ulimit.c
===================================================================
--- /trunk/libc/src/libc/process/ulimit.c	(revision 3880)
+++ /trunk/libc/src/libc/process/ulimit.c	(revision 3881)
@@ -1,3 +1,3 @@
-/* $Id: $ */
+/* $Id$ */
 /** @file
  *
Index: /trunk/libc/src/libc/process/wait.c
===================================================================
--- /trunk/libc/src/libc/process/wait.c	(revision 3880)
+++ /trunk/libc/src/libc/process/wait.c	(revision 3881)
@@ -1,3 +1,3 @@
-/* $Id: waitid.c,v 1.1 2004/11/08 09:57:37 bird Exp $ */
+/* $Id$ */
 /** @file
  *
Index: /trunk/libc/src/libc/process/waitpid.c
===================================================================
--- /trunk/libc/src/libc/process/waitpid.c	(revision 3880)
+++ /trunk/libc/src/libc/process/waitpid.c	(revision 3881)
@@ -1,3 +1,3 @@
-/* $Id: waitid.c,v 1.1 2004/11/08 09:57:37 bird Exp $ */
+/* $Id$ */
 /** @file
  *