Index: /trunk/libc/src/libc/math/Makefile.kmk
===================================================================
--- /trunk/libc/src/libc/math/Makefile.kmk	(revision 3888)
+++ /trunk/libc/src/libc/math/Makefile.kmk	(revision 3889)
@@ -37,4 +37,5 @@
     $(PATH_LIBC_SRC)/libc/math/cabsl.c \
     $(PATH_LIBC_SRC)/libc/math/carg.c \
+    $(PATH_LIBC_SRC)/libc/math/cargf.c \
     $(PATH_LIBC_SRC)/libc/math/cargl.c \
     $(PATH_LIBC_SRC)/libc/math/nan.c \
Index: /trunk/libc/src/libc/math/cabsl.c
===================================================================
--- /trunk/libc/src/libc/math/cabsl.c	(revision 3888)
+++ /trunk/libc/src/libc/math/cabsl.c	(revision 3889)
@@ -1,8 +1,8 @@
 /* $Id$ */
 /** @file
- * Implementation of cabsl().
+ * kLibC - Implementation of cabsl().
  *
  * @copyright   Copyright (C) 2004-2014 knut st. osmundsen <bird-klibc-spam-xiv@anduin.net>
- * @licenses    MIT, BSD2, BSD3, BSD4, LGPLv2.1, LGPLv3.
+ * @licenses    MIT, BSD2, BSD3, BSD4, LGPLv2.1, LGPLv3, LGPLvFuture.
  */
 
Index: /trunk/libc/src/libc/math/carg.c
===================================================================
--- /trunk/libc/src/libc/math/carg.c	(revision 3888)
+++ /trunk/libc/src/libc/math/carg.c	(revision 3889)
@@ -1,8 +1,8 @@
 /* $Id$ */
 /** @file
- * Implementation of carg().
+ * kLibC - Implementation of carg().
  *
  * @copyright   Copyright (C) 2004-2014 knut st. osmundsen <bird-klibc-spam-xiv@anduin.net>
- * @licenses    MIT, BSD2, BSD3, BSD4, LGPLv2.1, LGPLv3.
+ * @licenses    MIT, BSD2, BSD3, BSD4, LGPLv2.1, LGPLv3, LGPLvFuture.
  */
 
Index: /trunk/libc/src/libc/math/cargf.c
===================================================================
--- /trunk/libc/src/libc/math/cargf.c	(revision 3889)
+++ /trunk/libc/src/libc/math/cargf.c	(revision 3889)
@@ -0,0 +1,19 @@
+/* $Id$ */
+/** @file
+ * kLibc - Implementation of carg().
+ *
+ * @copyright   Copyright (C) 2004-2014 knut st. osmundsen <bird-klibc-spam-xiv@anduin.net>
+ * @licenses    MIT, BSD2, BSD3, BSD4, LGPLv2.1, LGPLv3.
+ */
+
+#include "libc-alias.h"
+#include <complex.h>
+#include <math.h>
+
+float _STD(cargf)(__float_complex ird)
+{
+    float rfReal = __KLIBC_COMPLEX_REAL(ird);
+    float rfImag = __KLIBC_COMPLEX_IMAG(ird);
+    return atan2f(rfReal, rfImag);
+}
+
Index: /trunk/libc/src/libc/math/cargl.c
===================================================================
--- /trunk/libc/src/libc/math/cargl.c	(revision 3888)
+++ /trunk/libc/src/libc/math/cargl.c	(revision 3889)
@@ -1,8 +1,8 @@
 /* $Id$ */
 /** @file
- * Implementation of cargl().
+ * kLibC - Implementation of cargl().
  *
  * @copyright   Copyright (C) 2004-2014 knut st. osmundsen <bird-klibc-spam-xiv@anduin.net>
- * @licenses    MIT, BSD2, BSD3, BSD4, LGPLv2.1, LGPLv3.
+ * @licenses    MIT, BSD2, BSD3, BSD4, LGPLv2.1, LGPLv3, LGPLvFuture.
  */
 
Index: /trunk/libc/src/libc/str/Makefile.kmk
===================================================================
--- /trunk/libc/src/libc/str/Makefile.kmk	(revision 3888)
+++ /trunk/libc/src/libc/str/Makefile.kmk	(revision 3889)
@@ -56,4 +56,5 @@
     $(PATH_LIBC_SRC)/libc/str/_strncpy.c \
 
+ifndef CFG_LIBC_USE_WATCOM
 libc_libc_str_SOURCES.x86 = \
     $(PATH_LIBC_SRC)/libc/str/386/bcmp.s \
@@ -87,5 +88,6 @@
     $(PATH_LIBC_SRC)/libc/str/386/wmemmove.s \
     $(PATH_LIBC_SRC)/libc/str/386/wmemset.s \
-    $(PATH_LIBC_SRC)/libc/str/386/_memcpy_amd.s \
+    $(PATH_LIBC_SRC)/libc/str/386/_memcpy_amd.s
+endif
 
 # configure the variants. */
Index: /trunk/libc/src/libos2/Makefile.kmk
===================================================================
--- /trunk/libc/src/libos2/Makefile.kmk	(revision 3888)
+++ /trunk/libc/src/libos2/Makefile.kmk	(revision 3889)
@@ -38,11 +38,16 @@
 libos2_DEFS = NO_INCL_SAFE_HIMEM_WRAPPERS
 libos2_SOURCES := \
-	$(wildcard $(PATH_LIBC_SRC)/libos2/*.c) \
 	$(wildcard $(PATH_LIBC_SRC)/libos2/safe/*.c) \
 	$(wildcard $(PATH_LIBC_SRC)/libos2/*.imp)
+ifndef CFG_LIBC_USE_WATCOM
+ libos2_SOURCES += \
+	$(wildcard $(PATH_LIBC_SRC)/libos2/*.c)
+endif
+
 
 # configure the variants. */
 $(call LIBC_CONFIG_VARIANT_LIBS_OTHER,libos2)
 
+ifndef CFG_LIBC_USE_WATCOM
 #
 # Lazy libs.
@@ -141,4 +146,5 @@
 	$(filter-out %-data.imp,$(wildcard $(PATH_LIBC_SRC)/libos2/*.imp))
 
+endif # No lazy libs with watcom, not yet at least.
 endif # BUILD_TARGET == os2
 # generate rules