Index: trunk/src/wininet/ftp.c
===================================================================
--- trunk/src/wininet/ftp.c	(revision 3897)
+++ trunk/src/wininet/ftp.c	(revision 3898)
@@ -1,3 +1,4 @@
-/*
+/* $Id: ftp.c,v 1.2 2000-07-29 14:10:08 bird Exp $
+ *
  * WININET - Ftp implementation
  *
@@ -40,17 +41,17 @@
 typedef enum {
   /* FTP commands with arguments. */
-  FTP_CMD_ACCT, 
-  FTP_CMD_CWD,  
-  FTP_CMD_DELE, 
-  FTP_CMD_MKD,  
-  FTP_CMD_PASS, 
-  FTP_CMD_PORT, 
-  FTP_CMD_RETR, 
-  FTP_CMD_RMD,  
-  FTP_CMD_RNFR, 
-  FTP_CMD_RNTO, 
-  FTP_CMD_STOR, 
-  FTP_CMD_TYPE, 
-  FTP_CMD_USER, 
+  FTP_CMD_ACCT,
+  FTP_CMD_CWD,
+  FTP_CMD_DELE,
+  FTP_CMD_MKD,
+  FTP_CMD_PASS,
+  FTP_CMD_PORT,
+  FTP_CMD_RETR,
+  FTP_CMD_RMD,
+  FTP_CMD_RNFR,
+  FTP_CMD_RNTO,
+  FTP_CMD_STOR,
+  FTP_CMD_TYPE,
+  FTP_CMD_USER,
 
   /* FTP commands without arguments. */
@@ -58,7 +59,7 @@
   FTP_CMD_LIST,
   FTP_CMD_NLST,
-  FTP_CMD_PWD, 
+  FTP_CMD_PWD,
   FTP_CMD_QUIT,
-} FTP_COMMAND; 
+} FTP_COMMAND;
 
 static const char *szFtpCommands[] = {
@@ -147,5 +148,5 @@
 
 		/* Accept connection from ftp server */
-		if (FTP_InitDataSocket(lpwfs, &nDataSocket)) 
+		if (FTP_InitDataSocket(lpwfs, &nDataSocket))
 		{
 	    		FTP_SendData(lpwfs, nDataSocket, hFile);
@@ -159,5 +160,5 @@
 	{
 	    	INTERNET_ASYNC_RESULT iar;
-	       
+
 		iar.dwResult = (DWORD)bSuccess;
 		iar.dwError = nRC;
@@ -217,5 +218,5 @@
 	{
 	    	INTERNET_ASYNC_RESULT iar;
-	       
+
 		iar.dwResult = (DWORD)bSuccess;
 		iar.dwError = nRC;
@@ -348,5 +349,5 @@
  *
  */
-BOOLAPI FtpGetCurrentDirectoryA(HINTERNET hFtpSession, LPSTR lpszCurrentDirectory, 
+BOOLAPI FtpGetCurrentDirectoryA(HINTERNET hFtpSession, LPSTR lpszCurrentDirectory,
 	LPDWORD lpdwCurrentDirectory)
 {
@@ -401,5 +402,5 @@
 	{
 	    	INTERNET_ASYNC_RESULT iar;
-	       
+
 		iar.dwResult = (DWORD)bSuccess;
 		iar.dwError = bSuccess ? ERROR_SUCCESS : ERROR_SUCCESS;
@@ -450,6 +451,6 @@
 	}
 
-	/* Accept connection from server */ 
-	if (nSuccess && FTP_InitDataSocket(lpwfs, &nDataSocket)) 
+	/* Accept connection from server */
+	if (nSuccess && FTP_InitDataSocket(lpwfs, &nDataSocket))
 	{
 		hFile = HeapAlloc(GetProcessHeap(), 0, sizeof(WININETFILE));
@@ -492,5 +493,5 @@
 
 	/* Ensure we can write to lpszNewfile by opening it */
-	hFile = CreateFileA(lpszNewFile, GENERIC_WRITE, 0, 0, fFailIfExists ? 
+	hFile = CreateFileA(lpszNewFile, GENERIC_WRITE, 0, 0, fFailIfExists ?
 		CREATE_NEW : CREATE_ALWAYS, dwLocalFlagsAttribute, 0);
 	if (INVALID_HANDLE_VALUE == hFile)
@@ -505,5 +506,5 @@
 
 		/* Accept connection from ftp server */
-		if (FTP_InitDataSocket(lpwfs, &nDataSocket)) 
+		if (FTP_InitDataSocket(lpwfs, &nDataSocket))
 		{
 		    	int nResCode;
@@ -523,5 +524,5 @@
 
 	if (hFile)
-		CloseHandle(hFile);    
+		CloseHandle(hFile);
 	return bSuccess;
 }
@@ -539,5 +540,5 @@
  */
 
-HINTERNET FTP_Connect(HINTERNET hInternet, LPCSTR lpszServerName, 
+HINTERNET FTP_Connect(HINTERNET hInternet, LPCSTR lpszServerName,
 	INTERNET_PORT nServerPort, LPCSTR lpszUserName,
 	LPCSTR lpszPassword, DWORD dwFlags, DWORD dwContext)
@@ -583,5 +584,5 @@
 	if (!result)
 	{
-	        TRACE("Connected to server\n"); 
+	        TRACE("Connected to server\n");
 		lpwfs = HeapAlloc(GetProcessHeap(), 0, sizeof(WININETFTPSESSIONA));
 		if (NULL == lpwfs)
@@ -654,5 +655,5 @@
 	{
 	    	INTERNET_ASYNC_RESULT iar;
-	       
+
 		iar.dwResult = (DWORD)lpwfs;
 		iar.dwError = bSuccess ? ERROR_SUCCESS : ERROR_INTERNET_CANNOT_CONNECT;
@@ -735,5 +736,5 @@
 	    return FALSE;
 	}
-	sprintf(buf, "%s%s%s%s", szFtpCommands[ftpCmd], bParamHasLen ? " " : "", 
+	sprintf(buf, "%s%s%s%s", szFtpCommands[ftpCmd], bParamHasLen ? " " : "",
 		bParamHasLen ? lpszParam : "", szCRLF);
 
@@ -787,5 +788,5 @@
 		nRecv = 0;
 	}
-		   
+
 	if (nRecv > 0)
 	{
@@ -820,5 +821,5 @@
 	if (!FTP_SendCommand(lpwfs->sndSocket, FTP_CMD_PASS, lpwfs->lpszPassword))
 	    goto lend;
-	   
+
 	nResCode = FTP_ReceiveResponse(lpwfs->sndSocket, lpwfs->lpszResponseBuffer, MAX_REPLY_LEN);
 	if (nResCode)
@@ -844,5 +845,5 @@
  *           FTP_SendAccount (internal)
  *
- * 
+ *
  *
  * RETURNS
@@ -943,5 +944,5 @@
 	lpwfs->lstnSocketAddress.sin_family = AF_INET;
 	lpwfs->lstnSocketAddress.sin_port = htons((u_short) 0);
-	lpwfs->lstnSocketAddress.sin_addr.s_addr = htonl(INADDR_ANY); 
+	lpwfs->lstnSocketAddress.sin_addr.s_addr = htonl(INADDR_ANY);
 	if (SOCKET_ERROR == bind(lpwfs->lstnSocket,&lpwfs->lstnSocketAddress, sizeof(struct sockaddr_in)))
 	{
@@ -1061,5 +1062,5 @@
  *           FTP_InitDataSocket (internal)
  *
- * 
+ *
  *
  * RETURNS
@@ -1128,5 +1129,5 @@
 		}
 
-		nLen = DATA_PACKET_SIZE < nBytesToSend ? 
+		nLen = DATA_PACKET_SIZE < nBytesToSend ?
 		    DATA_PACKET_SIZE : nBytesToSend;
 		nRC  = send(nDataSocket, lpszBuffer, nLen, 0);
@@ -1145,5 +1146,5 @@
 /*
 			TRACE( "%d bytes of %d bytes (%d%%) in %d min %d sec estimated remainig time %d sec\t\t\r",
-				nTotalSent, fi.nFileSizeLow, nTotalSent*100/st.st_size, nSeconds / 60, 
+				nTotalSent, fi.nFileSizeLow, nTotalSent*100/st.st_size, nSeconds / 60,
 				nSeconds % 60, (st.st_size - nTotalSent) * nSeconds / nTotalSent );
 */
@@ -1269,9 +1270,9 @@
 			if (nRC == 0)
 				goto recv_end;
-			WriteFile(hFile, lpszBuffer, nRC, &nBytesWritten, NULL); 
+			WriteFile(hFile, lpszBuffer, nRC, &nBytesWritten, NULL);
 			nBytesReceived += nRC;
 		}
 
-		TRACE("%d bytes of %ld (%ld%%)\r", nBytesReceived, nBytes, 
+		TRACE("%d bytes of %ld (%ld%%)\r", nBytesReceived, nBytes,
                   nBytesReceived * 100 / nBytes);
 	}
@@ -1331,5 +1332,5 @@
 BOOL FTP_CloseFindNextHandle(LPWININETFINDNEXTA lpwfn)
 {
-    int i; 
+    int i;
 
     for (i = 0; i < lpwfn->size; i++)
@@ -1367,5 +1368,5 @@
 	{
 		DWORD access = mktime(&lpafp->tmLastModified);
-		
+
 		/* Not all fields are filled in */
 		lpFindFileData->ftLastAccessTime.dwHighDateTime = HIWORD(access);
@@ -1384,5 +1385,5 @@
 		    lpwfn->lpafp = lpafp;
 		}
-	} 
+	}
 
 	return (HINTERNET)lpwfn;
@@ -1451,5 +1452,5 @@
 
 			sizeFilePropArray *= 2;
-			tmpafp = HeapReAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, *lpafp, 
+			tmpafp = HeapReAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, *lpafp,
 				sizeof(FILEPROPERTIESA)*sizeFilePropArray);
 			if (NULL == tmpafp)
@@ -1542,5 +1543,5 @@
 			LPFILEPROPERTIESA tmpafp;
 
-			tmpafp = HeapReAlloc(GetProcessHeap(), 0, *lpafp, 
+			tmpafp = HeapReAlloc(GetProcessHeap(), 0, *lpafp,
 				sizeof(FILEPROPERTIESA)*indexFilePropArray);
 			if (NULL == tmpafp)
@@ -1554,5 +1555,5 @@
 	}
 
-lend:	
+lend:
   return bSuccess;
 }
Index: trunk/src/wininet/internet.c
===================================================================
--- trunk/src/wininet/internet.c	(revision 3897)
+++ trunk/src/wininet/internet.c	(revision 3898)
@@ -1,3 +1,4 @@
-/*
+/* $Id: internet.c,v 1.2 2000-07-29 14:10:09 bird Exp $
+ *
  * Wininet
  *
@@ -70,5 +71,5 @@
  *
  */
-INTERNETAPI HINTERNET WINAPI InternetOpenA(LPCSTR lpszAgent, 
+INTERNETAPI HINTERNET WINAPI InternetOpenA(LPCSTR lpszAgent,
 	DWORD dwAccessType, LPCSTR lpszProxy,
     	LPCSTR lpszProxyBypass, DWORD dwFlags)
@@ -199,5 +200,5 @@
 	lpFindFileData = (LPWIN32_FIND_DATAA) lpvFindData;
 	access = mktime(&lpwh->lpafp[lpwh->index].tmLastModified);
-		
+
 	/* Not all fields are filled in */
 	lpFindFileData->ftLastAccessTime.dwHighDateTime = HIWORD(access);
@@ -245,5 +246,5 @@
 			retval = FTP_CloseFindNextHandle((LPWININETFINDNEXTA) lpwh);
 			break;
-		
+
 		default:
 			break;
@@ -264,5 +265,5 @@
  *
  */
-BOOLAPI InternetCrackUrlA(LPCSTR lpszUrl, DWORD dwUrlLength, DWORD dwFlags, 
+BOOLAPI InternetCrackUrlA(LPCSTR lpszUrl, DWORD dwUrlLength, DWORD dwFlags,
 		LPURL_COMPONENTSA lpUrlComponents)
 {
@@ -372,5 +373,5 @@
 	// [<user>[<:password>]@]<host>[:<port>]
 	// First find the user and password if they exist...
-			
+
 	szHost = strchr( szNetLoc, '@' );
 	if( szHost == NULL )
@@ -458,5 +459,5 @@
  *
  * Sets up a callback function which is called as progress is made
- * during an operation. 
+ * during an operation.
  *
  * RETURNS
@@ -473,5 +474,5 @@
 	TRACE("\n");
 	if (lpwai->hdr.htype != WH_HINIT)
-    		return INTERNET_INVALID_STATUS_CALLBACK; 
+    		return INTERNET_INVALID_STATUS_CALLBACK;
 
 	retVal = lpwai->lpfnStatusCB;
@@ -485,5 +486,5 @@
  *           InternetWriteFile (WININET.138)
  *
- * Write data to an open internet file 
+ * Write data to an open internet file
  *
  * RETURNS
@@ -506,5 +507,5 @@
 	{
 		case WH_HHTTPREQ:
-		    	nSocket = ((LPWININETHTTPREQA)hFile)->nSocketFD; 
+		    	nSocket = ((LPWININETHTTPREQA)hFile)->nSocketFD;
 			break;
 
@@ -533,5 +534,5 @@
  *           InternetReadFile (WININET.121)
  *
- * Read data from an open internet file 
+ * Read data from an open internet file
  *
  * RETURNS
@@ -540,5 +541,5 @@
  *
  */
-BOOLAPI InternetReadFile(HINTERNET hFile, LPVOID lpBuffer, 
+BOOLAPI InternetReadFile(HINTERNET hFile, LPVOID lpBuffer,
 	DWORD dwNumOfBytesToRead, LPDWORD dwNumOfBytesRead)
 {
@@ -554,5 +555,5 @@
 	{
 		case WH_HHTTPREQ:
-		    	nSocket = ((LPWININETHTTPREQA)hFile)->nSocketFD; 
+		    	nSocket = ((LPWININETHTTPREQA)hFile)->nSocketFD;
 			break;
 
Index: trunk/src/wininet/utility.c
===================================================================
--- trunk/src/wininet/utility.c	(revision 3897)
+++ trunk/src/wininet/utility.c	(revision 3898)
@@ -1,3 +1,4 @@
-/* 
+/* $Id: utility.c,v 1.2 2000-07-29 14:10:09 bird Exp $
+ *
  * Wininet - Utility functions
  *
@@ -38,5 +39,5 @@
 	//Assert that the string is the expected length
 	if (tmpChar[TIME_STRING_LEN] != '\0')
-	{ 
+	{
 		tmpChar[TIME_STRING_LEN] = '\0';
 		FIXME("\n");
@@ -59,5 +60,5 @@
 	SystemTime.tm_min = atoi(tmpChar+20);
 	SystemTime.tm_sec = atoi(tmpChar+23);
-	
+
 	//and month
 	tmpChar2 = tmpChar + 8;